/*
    Tickle class library

    Copyright (c) 2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef EMU_JOYSTICK2PORT_H_
#define EMU_JOYSTICK2PORT_H_

#include "emu_event2port.h"
#include "emu_input.h"
#include "emu_math.h"

class TJoystickToPortHandler
{
public:
    /** Destructor. */
    virtual ~TJoystickToPortHandler();

    void setPort( int index, unsigned char * port, unsigned char and_mask, unsigned char or_mask = 0 );

    bool handleInputEvent( unsigned device, unsigned param );

protected:
    TJoystickToPortHandler( unsigned device, int type, int ways );

    virtual bool onJoystickMoved( int x, int y ) = 0;

    unsigned char * port( int index ) const {
        return port_[index];
    }

    unsigned char and_mask( int index ) const {
        return and_mask_[index];
    }

    unsigned char or_mask( int index ) const {
        return or_mask_[index];
    }

    int xpos() const {
        return xpos_;
    }

    int ypos() const {
        return ypos_;
    }

    void setXPos( int pos ) {
        xpos_ = pos;
    }

    void setYPos( int pos ) {
        ypos_ = pos;
    }

    void setDirection( int direction );

private:
    unsigned device_;
    int type_;
    int ways_;
    int direction_;
    int xpos_;
    int ypos_;
    unsigned char ** port_;
    unsigned char * and_mask_;
    unsigned char * or_mask_;
};


class TJoy4WayToPortHandler : public TJoystickToPortHandler
{
public:
    TJoy4WayToPortHandler( unsigned device, int type );

    TJoy4WayToPortHandler( unsigned device, int type, unsigned char * port, unsigned masks );

    void setPortAndMasks( unsigned char * port, unsigned masks );

protected:
    virtual bool onJoystickMoved( int x, int y );
};

#endif // EMU_JOYSTICK2PORT_H_
