#ifndef EMU_MEMORY_IOSTREAM_H_
#define EMU_MEMORY_IOSTREAM_H_

#include "emu_iostream.h"

#include <string.h>

class TMemoryInputStream : public TInputStream
{
public:
    TMemoryInputStream( const unsigned char * data, unsigned size ) : data_(data), size_(size) {
        offset_ = 0;
    }

    virtual ~TMemoryInputStream() {
    }

    virtual unsigned read( void * buf, unsigned len ) {
        unsigned result = 0;

        if( offset_ < size_ ) {
            unsigned max_len = size_ - offset_;

            if( len > max_len ) {
                len = max_len;
            }

            memcpy( buf, data_+offset_, len );
            offset_ += len;

            result = len;
        }

        return result;
    }

private:
    const unsigned char * data_;
    unsigned size_;
    unsigned offset_;
};

#endif // EMU_MEMORY_IOSTREAM_H_
