#ifndef KEYPRESS_DISPATCHER_H_
#define KEYPRESS_DISPATCHER_H_

#include <emu/emu_joystick.h>
#include <emu/emu_machine.h>

struct KeyPressDispatcherItem;

class KeyPressDispatcher
{
public:
    KeyPressDispatcher();

    ~KeyPressDispatcher();

    void add( unsigned key, unsigned id, unsigned data = 0 );

    void setJoystick( int index, unsigned kleft, unsigned kright, unsigned kup, unsigned kdown );

    void clear();

    bool handle( unsigned key, unsigned param, TMachine * machine );

    TJoystick * joystick( int index ) {
        return joysticks_[index];
    }

private:
    void expand();

    int count_;
    int capacity_;
    KeyPressDispatcherItem * items_;
    TJoystick * joysticks_[4];
};

#endif // KEYPRESS_DISPATCHER_H_
