/*
    Tickle front-end
    User interface for Linux/Qt

    Copyright (c) 2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <qimage.h>

#include <emu/emu.h>

class LinuxFrame : public TFrame
{
public:
    LinuxFrame( int w, int h ) {
        screen_ = new QImage( w, h, 32 );
        max_voices_ = 0;
    }
    
    virtual ~LinuxFrame() {
        delete screen_;
    }

    virtual void setVideo( TBitmap * bitmap, bool flipped = false );

    virtual TMixer * getMixer() {
        return &mixer_;
    }
    
    QImage * screen() {
        return screen_;
    }
    
    int maxVoices() {
        max_voices_ = TMath::max( mixer_.maxVoicesPerChannel(), max_voices_ );

        return max_voices_;
    }

private:
    QImage * screen_;
    TMixerMono mixer_;
    int max_voices_;
};
